"""
Pre-initialization for FloorPlan1 task.
FloorPlan1 does not need any modifications for the task
of putting the bread, lettuce, and tomato in the fridge
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bread|-00.52|+01.17|-00.03',
        position={'x': -0.5223836302757263, 'y': 1.1704490184783936, 'z': -0.028279857710003853}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Tomato|-00.39|+01.14|-00.81',
        position={'x': -0.3850487172603607, 'y': 1.1370320320129395, 'z': -0.8119611740112305}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Lettuce|-01.81|+00.97|-00.94',
        position={'x': -1.8069753646850586, 'y': 0.9737616777420044, 'z': -0.9429943561553955}
        )
                    
        return event
            