"""
Pre-initialization for FloorPlan202 task.
FloorPlan202 does not need any modifications for the task of putting items on a sofa.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
        # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Laptop|-03.22|+00.61|+00.58',
        position={'x': -3.2156782150268555, 'y': 0.614728569984436, 'z': 0.582680344581604}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Book|-01.94|+00.70|+03.61',
        position={'x': -1.9425640106201172, 'y': 0.7040524482727051, 'z': 3.612591505050659}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='RemoteControl|-01.27|+00.44|+02.15',
        position={'x': -1.273537278175354, 'y': 0.4441750645637512, 'z': 2.1527974605560303}
        )
                    
        return event
            