"""
Pre-initialization for FloorPlan203 task.
FloorPlan203 does not need any modifications for the task of putting items on a sofa.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
        # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Laptop|+00.38|+00.55|+02.83',
        position={'x': 0.37899649143218994, 'y': 0.5504863262176514, 'z': 2.834003448486328}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Book|-03.72|+00.76|-00.64',
        position={'x': -3.7189955711364746, 'y': 0.7563936710357666, 'z': -0.644997775554657}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='RemoteControl|-01.27|+00.45|+03.29',
        position={'x': -1.2715975046157837, 'y': 0.44544124603271484, 'z': 3.294555187225342}
        )
                    
        return event
            