"""
Pre-initialization for FloorPlan224 task.
FloorPlan224 does not need any modifications for the task of putting small valuables on a sofa
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Laptop|-02.78|+00.38|-01.87',
        position={'x': -2.7807068824768066, 'y': 0.375164657831192, 'z': -1.87490975856781}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Book|+00.12|+00.92|+01.11',
        position={'x': 0.11690093576908112, 'y': 0.9207341074943542, 'z': 1.1098647117614746}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='RemoteControl|-00.26|+00.92|+00.95',
        position={'x': -0.2560768723487854, 'y': 0.9219199419021606, 'z': 0.9483048915863037}
        )
                    
        return event
            