"""
Pre-initialization for FloorPlan1 task.
FloorPlan1's objects butter knife, bowl, and mug are moved to go the floor so the agent(s) can pick them up
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='ButterKnife|-00.41|+01.11|-00.46',
        position={'x': -0.7848841965198516, 'y': 0.5653320550918579, 'z': 0.08746650218963625}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bowl|+00.27|+01.10|-00.75',
        position={'x': 1.2680586993694307, 'y': 0.5610208511352539, 'z': 0.3456790924072266}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Mug|-01.76|+00.90|-00.62',
        position={'x': -1.2633564710617065, 'y': 0.3600000739097595, 'z': -1.7195747375488282}
        )
                    
        return event
            