"""
Pre-initialization for FloorPlan2 task.
FloorPlan2 does not need any modifications for the task
of putting the butter knife, mug, and bowl in the countertop.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bowl|+00.28|+00.92|+01.09',
        position={'x': 0.8565313518047333, 'y': 0.37550547122955324, 'z': 2.291195821762085}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Mug|-00.24|+00.92|-00.26',
        position={'x': -0.9600059986114502, 'y': 0.37437602281570437, 'z': -1.0059997737407684}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='ButterKnife|+01.67|+00.69|-00.11',
        position={'x': 1.2330197095870972, 'y': 0.15010871887207033, 'z': -0.563984391093254}
        )
                    
        return event
            