"""
Pre-initialization for FloorPlan3 task.
FloorPlan3 does not need any modifications for the task
of putting the butter knife, mug, and bowl in the countertop.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='ButterKnife|-01.57|+01.32|+01.35',
        position={'x': -1.0931251049041748, 'y': 0.5415087223052978, 'z': 2.0434011220932007}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bowl|-01.82|+01.31|+00.27',
        position={'x': -0.8725947141647339, 'y': 0.5388092279434203, 'z': -1.8218575716018677}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Mug|-01.97|+01.04|-00.43',
        position={'x': -1.027457356452942, 'y': 0.26826219558715814, 'z': 0.96675905585289}
        )
                    
        return event
            