"""
Pre-initialization for FloorPlan4 task.
FloorPlan4 does not need any modifications for the task
of putting the butter knife, mug, and bowl in the countertop.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='ButterKnife|-02.63|+01.11|+00.60',
        position={'x': -3.1227486610412596, 'y': 0.4506048440933227, 'z': 1.069891631603241}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bowl|-00.50|+01.04|+02.22',
        position={'x': -0.49500441551208496, 'y': 0.3785270929336547, 'z': 1.2911748886108398}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Mug|-00.38|+01.09|+03.19',
        position={'x': -1.369706040620804, 'y': 0.43095331192016595, 'z': 2.2613508701324463}
        )
                    
        return event
            