"""
Pre-initialization for FloorPlan202 task.
FloorPlan202 does not need any modifications for the task of putting small valuables in a box.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
        # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='KeyChain|-01.01|+00.70|+03.53',
        position={'x': -1.00753915309906, 'y': 0.7043681740760803, 'z': 3.530571699142456}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Watch|-01.22|+00.70|+03.47',
        position={'x': -1.2187483310699463, 'y': 0.7040449380874634, 'z': 3.471052408218384}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='RemoteControl|-01.27|+00.44|+02.15',
        position={'x': -1.273537278175354, 'y': 0.4441750645637512, 'z': 2.1527974605560303}
        )
                    
        return event
            