"""
Pre-initialization for FloorPlan215 task.
FloorPlan215 does not need any modifications for the task of putting valuables in a box.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='KeyChain|-00.56|+00.80|+02.45',
        position={'x': -0.5580741763114929, 'y': 0.7961701154708862, 'z': 2.4460489749908447}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Watch|-02.74|+00.51|+04.21',
        position={'x': -2.740730047225952, 'y': 0.5108616352081299, 'z': 4.208452224731445}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='RemoteControl|-02.35|+00.51|+04.49',
        position={'x': -2.350358486175537, 'y': 0.5122511386871338, 'z': 4.493183135986328}
        )
                    
        return event
            