"""
Pre-initialization for FloorPlan228 task.
FloorPlan228 does not need any modifications for the task of putting valuables in a box.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='KeyChain|-03.77|+00.39|+02.34',
        position={'x': -3.772420644760132, 'y': 0.3913199305534363, 'z': 2.337993621826172}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Watch|-04.18|+00.39|+02.25',
        position={'x': -4.177576065063477, 'y': 0.39112070202827454, 'z': 2.248626470565796}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='RemoteControl|-03.76|+00.39|+02.87',
        position={'x': -3.765334367752075, 'y': 0.3903893232345581, 'z': 2.8747355937957764}
        )
                    
        return event
            