"""
Pre-initialization for FloorPlan2 task.
FloorPlan2: the tomato, bread, and egg moved to seperate
counters away from group 
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass

    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """

            # initialization function - autogenerated

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId='Bread|+00.26|+00.99|-00.08',
            position= {'x': 0.25613731145858765, 'y': 0.9874744415283203, 'z': -0.07600238919258118}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId='Tomato|+00.17|+00.97|-00.28',
            position= {'x': -1.4112820625305176, 'y': 1.0045000314712524, 'z': -1.1034314632415771}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Egg|+00.13|+00.95|-00.17',
            position= {'x': -0.2585050332546234, 'y': 0.9874744415283203, 'z': 0.5799306869506836}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Lettuce|-01.71|+00.82|-00.14',
            position= {'x': -0.2285050332546234, 'y': 0.9874744415283203, 'z': 0.051799306869506836}
        )


        return event