"""
Pre-initialization for FloorPlan3 task.
FloorPlan3: egg doesn't need to be moved
tomato needs to be taken out of fridge and placed on
countertop
- switch position of pot and bread
- put lettuce in front of toaster
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass

    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """

            # initialization function - autogenerated


        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Egg|-01.57|+01.36|-01.05',
            position= {'x': -1.5661152601242065, 'y': 1.356042504310608, 'z': -1.0532528162002563}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Tomato|+00.92|+01.91|+01.61',
            position = {'x': -1.6, 'y': 1.313399314880371, 'z': -2.156033754348755}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId='Pot|-01.58|+01.31|-01.58',
            position= {'x': -1.5136305093765259, 'y': 1.3809161186218262, 'z': 0.9621981263160706}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId='Bread|-01.51|+01.38|+00.66',
            position= {'x': -1.5770851373672485, 'y': 1.313399314880371, 'z': -1.5840153694152832}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId='Lettuce|-01.89|+01.40|-01.07',
            position= {'x': -1.4859903812408447, 'y': 1.3103996515274048, 'z': -2.512998342514038}
        )

        return event