"""
Pre-initialization for FloorPlan5 task.
FloorPlan5 bowl, mug, pot, and pan were dirtied
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass

    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.

        Args:
            event: env.event object
            controller: ai2thor.controller object

        Returns:
            event: env.event object
        """

            # initialization function - autogenerated

        event=controller.step(
            action='DirtyObject',
            objectId="Bowl|-00.51|+01.12|+00.54",
            forceAction=True,
        )

        event=controller.step(
            action='DirtyObject',
            objectId='Mug|+00.13|+01.12|+00.57',
            forceAction=True,
        )

        event=controller.step(
            action='DirtyObject',
            objectId='Pan|+01.74|+00.90|-01.97',
            forceAction=True,
        )

        event=controller.step(
            action='DirtyObject',
            objectId='Pot|-01.09|+00.90|+00.24',
            forceAction=True,
        )

        return event
