"""
Pre-initialization for FloorPlan5 task.
FloorPlan5's cabinets are closed so the agent can later open
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.15|+02.02|+00.38',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.15|+02.27|-01.42',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.45|+00.47|-00.01',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.46|+02.27|-02.00',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+00.12|+02.27|-02.00',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.42|+00.37|-00.01',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.84|+00.47|-00.05',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.84|+00.47|-01.67',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.82|+00.47|-01.69',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+01.38|+00.46|-01.69',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.15|+02.02|-01.98',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.10|+02.02|-02.00',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+00.20|+02.02|-02.00',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+01.18|+02.02|-02.00',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+01.75|+02.02|-01.40',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+01.75|+02.02|-01.03',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+01.39|+00.47|-01.06',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+01.74|+02.02|-02.00',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.15|+02.27|-00.84',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.15|+02.02|-00.77',
        forceAction=True
        )
                        
        return event
            