"""
Pre-initialization for FloorPlan4 task.
FloorPlan4 needs to move the tomato out of the fridge
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass

    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.

        Args:
            event: env.event object
            controller: ai2thor.controller object

        Returns:
            event: env.event object
        """

            # initialization function - autogenerated
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bread|-00.18|+01.12|+01.89',
        position={'x': -0.18400000035762787, 'y': 1.1191563606262207, 'z': 1.8919998407363892}
        )

        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Tomato|-00.75|+01.08|+02.40',
        position={'x': -0.7468804717063904, 'y': 1.0815153121948242, 'z': 2.3995256423950195}
        )

        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Lettuce|-03.31|+00.97|+03.04',
        position={'x': -0.7064676165580748, 'y': 1.9657654047012327, 'z': 1.8788126707077026}
        )

        return event
