"""
Pre-initialization for FloorPlan3 task.
FloorPlan3:
- Mug can be left on the coffee machine on the table
- Bowl and plate on the table behind the fridge
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass

    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """

            # initilization function - autogenerated

        event = controller.step(action="RotateRight", degrees=90)

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Bowl|-01.82|+01.31|+00.27',
            position = {'x': -1.5136305093765259, 'y': 1.313010334968567, 'z': 0.9621977210044861}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Plate|-01.47|+01.31|+00.24',
            position = {'x': -1.4670003652572632, 'y': 1.3114875555038452, 'z': 0.2439998835325241}
        )

        event=controller.step(
            action='PlaceObjectAtPoint',
            objectId= 'Mug|-01.97|+01.04|-00.43',
            position = {'x': -1.6136305093765259, 'y': 1.3809161186218262, 'z': 1.7821981263160706}
        )

        return event