"""
Pre-initialization for FloorPlan1 task.
FloorPlan1 does not need any modifications for the task
of clearing the table.
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bread|-00.52|+01.17|-00.03',
        position={'x': -0.5223836302757263, 'y': 1.1704490184783936, 'z': -0.02827983908355236}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Apple|-00.47|+01.15|+00.48',
        position={'x': -0.46516111493110657, 'y': 1.1512254476547241, 'z': 0.4758017659187317}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Tomato|-00.39|+01.14|-00.81',
        position={'x': -0.38504859805107117, 'y': 1.1370320320129395, 'z': -0.81196129322052}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Knife|-01.70|+00.79|-00.22',
        position={'x': -0.41180744767189026, 'y': 1.1053320169448853, 'z': -0.462016224861145}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bowl|+00.27|+01.10|-00.75',
        position={'x': 0.2731873691082001, 'y': 1.1010208129882812, 'z': -0.7532863616943359}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Book|+00.15|+01.10|+00.62',
        position={'x': 0.15499891340732574, 'y': 1.0992441177368164, 'z': 0.6169993877410889}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='CreditCard|-00.46|+01.10|+00.87',
        position={'x': 0.03377098441123966, 'y': 1.1003447771072388, 'z': 1.4147523283958434}
        )
                    
        return event
            