"""
Pre-initialization for FloorPlan1 task.
FloorPlan1 does not need any modifications for the task
of putting utensils in the sink
"""

class SceneInitializer:
    def __init__(self) -> None:
        pass
        
    def preinit(self, event, controller):
        """Pre-initialize the environment for the task.
    
        Args:
            event: env.event object
            controller: ai2thor.controller object
    
        Returns:
            event: env.event object
        """
    
            # initialization function - autogenerated
    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='ButterKnife|-00.41|+01.11|-00.46',
        position={'x': -0.41180744767189026, 'y': 1.1053320169448853, 'z': -0.462016224861145}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Bowl|+00.27|+01.10|-00.75',
        position={'x': 0.2731873691082001, 'y': 1.1010208129882812, 'z': -0.7532863616943359}
        )
                    
        event=controller.step(
        action='PlaceObjectAtPoint',
        objectId='Mug|-01.76|+00.90|-00.62',
        position={'x': -1.7607921361923218, 'y': 0.9000000357627869, 'z': -0.6206092834472656}
        )
                    
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+00.68|+00.50|-02.20',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.18|+00.50|-02.20',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.55|+00.50|+00.38',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+00.72|+02.02|-02.46',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.85|+02.02|+00.38',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|+00.68|+02.02|-02.46',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.55|+00.50|-01.97',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-01.69|+02.02|-02.46',
        forceAction=True
        )
                        
        event=controller.step(
        action='CloseObject',
        objectId='Cabinet|-00.73|+02.02|-02.46',
        forceAction=True
        )
                        
        return event
            